package com.company.jmixreportsexportdata.view.student;

import com.company.jmixreportsexportdata.entity.Student;
import com.company.jmixreportsexportdata.view.main.MainView;
import com.vaadin.flow.component.ClickEvent;
import com.vaadin.flow.router.Route;
import io.jmix.core.DataManager;
import io.jmix.flowui.kit.component.button.JmixButton;
import io.jmix.flowui.model.CollectionLoader;
import io.jmix.flowui.view.*;
import io.jmix.reports.runner.ReportRunner;
import io.jmix.reports.yarg.reporting.ReportOutputDocument;
import io.jmix.reportsflowui.runner.UiReportRunner;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.ArrayList;
import java.util.List;

@Route(value = "students", layout = MainView.class)
@ViewController("Student.list")
@ViewDescriptor("student-list-view.xml")
@LookupComponent("studentsDataGrid")
@DialogMode(width = "64em")
public class StudentListView extends StandardListView<Student> {

    @Autowired
    private DataManager dataManager;
    @ViewComponent
    private CollectionLoader<Student> studentsDl;
    @Autowired
    private UiReportRunner uiReportRunner;

    @Subscribe(id = "generateBtn", subject = "clickListener")
    public void onGenerateBtnClick(final ClickEvent<JmixButton> event) {
        List<Student> students = new ArrayList<>();
        for (int i = 0; i < 10000; i++) {
            Student student = dataManager.create(Student.class);
            student.setAge(25);
            student.setName("Student - " + (i + 1));

            students.add(student);
        }

        dataManager.save(students);
        studentsDl.load();
    }

    @Subscribe(id = "reportBtn", subject = "clickListener")
    public void onReportBtnClick(final ClickEvent<JmixButton> event) {
        uiReportRunner.byReportCode("students-report")
                .runAndShow();
    }
}